Attribute VB_Name = "basMain"
Option Explicit

Public Const ciTableNone        As Integer = 0
Public Const ciTableWaiwai      As Integer = 1
'Public Const ciTableNormal      As Integer = 2
Public Const ciTableRanking     As Integer = 4
Public Const ciTableUpRanking   As Integer = 8
Public Const ciTable3Play       As Integer = 256
Public Const ciTable4Play       As Integer = 512
Public Const ciTableTonpu       As Integer = 1024
Public Const ciTableTonnan      As Integer = 2048
Public Const ciGraphPoint       As Integer = 1
Public Const ciGraphRank        As Integer = 2
Public Const ciGraphWinValue    As Integer = 4
Public Const ciGraphFlowR       As Integer = 8
Public Const ciGraphFlowPnt     As Integer = 16
Public Const ciWinValue         As Integer = 8
Public Const ciUserWindow       As Integer = 1
Public Const ciRankWindow       As Integer = 2
Public Const ciStageWindow      As Integer = 4
Public Const ciWinWindow        As Integer = 8
Public Const ciGraphWindow      As Integer = 16

Public fMainForm As frmMain

Public Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Public Declare Function ShellExecute Lib "SHELL32" Alias "ShellExecuteA" (ByVal hWnd&, ByVal lpOperation$, ByVal lpFile$, ByVal lpParameters$, ByVal lpDirectory$, ByVal nShowCmd&) As Long
Public Declare Function MoveWindow Lib "USER32" (ByVal hWnd&, ByVal X&, ByVal Y&, ByVal nWidth&, ByVal nHeight&, ByVal bRepaint&) As Long
Public Declare Function GetClientRect Lib "USER32" (ByVal hWnd&, lpRect As RECT) As Long

Sub Main()
'---------------------------------------------------------------------------
'    : main()
' @@@\ : ʏo͏C
' @@ : Ȃ
'   l : Ȃ
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Set fMainForm = New frmMain

    trReadIniFile
    trInitFixedInfo
    With fMainForm
        .Width = basParam.trParamValue(csMainWidth)
        .Height = basParam.trParamValue(csMainHeight)
        .Show
    End With
End Sub

Public Function trFileExists(psPath As String, piType As Long) As Boolean
'---------------------------------------------------------------------------
'    : trFileExists()
' @@@\ : t@C̑݃`FbN
' @@ : (I) psPath         t@CifBNgj
'          : (I) piType         t@C^Cv
'   l : True= ݂, False= ݂Ȃ
' @@ : 1998/09/21
'---------------------------------------------------------------------------
    On Error GoTo trFileExists_Error
    If (GetAttr(psPath) And piType) = piType Then
        trFileExists = True
    Else
        trFileExists = False
    End If

    Exit Function
trFileExists_Error:
    trFileExists = False
End Function

Public Function trGetColor(psBefColor As String)
'---------------------------------------------------------------------------
'    : trGetColor()
' @@@\ : F񕶎񂩂Fԍ擾
' @@ : (I) psBefColor     ϊF
'   l : Ȃ
' @@ : 1998/12/11
'---------------------------------------------------------------------------
    Dim llRed           As Long         ' Fiԁj
    Dim llGreen         As Long         ' Fi΁j
    Dim llBlue          As Long         ' Fij

    llRed = Val(Mid(psBefColor, 1, 3))
    llGreen = Val(Mid(psBefColor, 4, 3))
    llBlue = Val(Mid(psBefColor, 7, 3))

    trGetColor = RGB(llRed, llGreen, llBlue)
End Function
