Attribute VB_Name = "basParam"
Option Explicit

' p[^L[
Public Const csMainWidth        As String = "MainWidth"
Public Const csMainHeight       As String = "MainHeight"
Public Const csVisibleWindow    As String = "VisibleWindow"
Public Const csMainToolbar      As String = "MainToolbar"
'Public Const csMainStatusbar    As String = "MainStatusbar"

Public Const csScoreFile        As String = "ScoreFile"
Public Const csUserName         As String = "UserName"
Public Const csSpecifyDate      As String = "SpecifyDate"
Public Const csStartDate        As String = "StartDate"
Public Const csStartTime        As String = "StartTime"
Public Const csEndDate          As String = "EndDate"
Public Const csEndTime          As String = "EndTime"
Public Const csTableKind1       As String = "TableKind1"
Public Const csTableKind2       As String = "TableKind2"

Public Const csAutoCalc         As String = "AutoCalc"
Public Const csCheckLine        As String = "CheckLine"

Public Const csGraphWidth       As String = "GraphWidth"
Public Const csGraphHeight      As String = "GraphHeight"
'Public Const csGraphSelect      As String = "GraphSelect"
Public Const csGraphDisp        As String = "GraphDisp"
Public Const csGraphFore        As String = "GraphFore"
Public Const csGraphBack        As String = "GraphBack"
Public Const csGraphPoint       As String = "GraphPoint"
Public Const csGraphRank        As String = "GraphRank"
Public Const csGraphPart        As String = "GraphPart"
Public Const csGraphFlowR       As String = "GraphFlowR"
Public Const csGraphFlowPnt     As String = "GraphFlowPnt"

'Public Const csHelpFileName     As String = "HelpFileName"

' ftHgl
Private Const ciDefVisWindow    As Integer = 31
Private Const ciDefTableKind1   As Integer = 773
Private Const ciDefTableKind2   As Integer = 773
Private Const clDefCheckLine    As Integer = 100
Private Const ciDefGraphDisp    As Integer = 31
Private Const csDefGraphFore    As String = "000000000"
Private Const csDefGraphBack    As String = "255255255"
Private Const csDefGraphPoint   As String = "255000000"
Private Const csDefGraphRank    As String = "255128064"
Private Const csDefGraphPart    As String = "000128000"
Private Const csDefGraphFlowR   As String = "000128255"
Private Const csDefGraphFlowPnt As String = "128000128"

' o[
Private mlMainWidth         As Long         ' CEBhE
Private mlMainHeight        As Long         ' CEBhE
Private miVisibleWindow     As Integer      ' EBhE\
Private mbMainToolbar       As Boolean      ' c[o[\tO
'Private mbMainStatusbar   As Boolean    ' Xe[^Xo[\tO

Private msScoreFile         As String       ' XRAt@C
Private msUserName          As String       ' [U[
Private mbSpecifyDate       As Boolean      ' tw̗L
Private mdStartDate         As Date         ' Jnt
Private mdStartTime         As Date         ' Jn
Private mdEndDate           As Date         ' It
Private mdEndTime           As Date         ' I
Private miTableKind1        As Integer      ' ΐ
Private miTableKind2        As Integer      ' 

Private mbAutoCalc          As Boolean      ' グvZtO
Private mlCheckLine         As Long         ' `FbNs̒P

Private mlGraphWidth        As Long         ' OtEBhE
Private mlGraphHeight       As Long         ' OtEBhE
'Private mbGraphSelect     As Boolean    ' Ot{^\tO
Private miGraphDisp         As Integer      ' \Ot
Private msGraphFore         As String       ' OtFiOiFj
Private msGraphBack         As String       ' OtFiwiFj
Private msGraphPoint        As String       ' OtFi_Fj
Private msGraphRank         As String       ' OtFiʐFj
Private msGraphPart         As String       ' OtFi|ʐFj
Private msGraphFlowR        As String       ' OtFiqڐFj
Private msGraphFlowPnt      As String       ' OtFiv_Fj

'Private msHelpFileName    As String     ' wvt@CpX

Public Property Get trParamValue(ByVal psParamKey As String) As Variant
'---------------------------------------------------------------------------
'    : trParamValue()
' @@@\ : p[^l̎擾
' @@ : (I) psParamKey     p[^L[
'   l : p[^l
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csScoreFile
        trParamValue = msScoreFile
    Case csUserName
        trParamValue = msUserName
    Case csSpecifyDate
        trParamValue = mbSpecifyDate
    Case csStartDate
        trParamValue = mdStartDate
    Case csStartTime
        trParamValue = mdStartTime
    Case csEndDate
        trParamValue = mdEndDate
    Case csEndTime
        trParamValue = mdEndTime
    Case csTableKind1
        trParamValue = miTableKind1
    Case csTableKind2
        trParamValue = miTableKind2

    Case csAutoCalc
        trParamValue = mbAutoCalc
    Case csCheckLine
        trParamValue = mlCheckLine

    Case csGraphWidth
        trParamValue = mlGraphWidth
    Case csGraphHeight
        trParamValue = mlGraphHeight
'    Case csGraphSelect
'        trParamValue = mbGraphSelect
    Case csGraphDisp
        trParamValue = miGraphDisp
    Case csGraphFore
        trParamValue = msGraphFore
    Case csGraphBack
        trParamValue = msGraphBack
    Case csGraphPoint
        trParamValue = msGraphPoint
    Case csGraphRank
        trParamValue = msGraphRank
    Case csGraphPart
        trParamValue = msGraphPart
    Case csGraphFlowR
        trParamValue = msGraphFlowR
    Case csGraphFlowPnt
        trParamValue = msGraphFlowPnt

'    Case csHelpFileName
'        trParamValue = msHelpFileName

    Case csMainWidth
        trParamValue = mlMainWidth
    Case csMainHeight
        trParamValue = mlMainHeight
    Case csVisibleWindow
        trParamValue = miVisibleWindow
    Case csMainToolbar
        trParamValue = mbMainToolbar
'    Case csMainStatusbar
'        trParamValue = mbMainStatusbar

    End Select
End Property

Public Property Let trParamValue(ByVal psParamKey As String, ByVal pvParamValue As Variant)
'---------------------------------------------------------------------------
'    : trParamValue()
' @@@\ : p[^l̐ݒ
' @@ : (I) psParamKey     p[^L[
'          : (I) pvParamValue   p[^l
'   l : Ȃ
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csScoreFile
        msScoreFile = pvParamValue
    Case csUserName
        msUserName = pvParamValue
    Case csSpecifyDate
        mbSpecifyDate = pvParamValue
    Case csStartDate
        mdStartDate = pvParamValue
    Case csStartTime
        mdStartTime = pvParamValue
    Case csEndDate
        mdEndDate = pvParamValue
    Case csEndTime
        mdEndTime = pvParamValue
    Case csTableKind1
        miTableKind1 = pvParamValue
    Case csTableKind2
        miTableKind2 = pvParamValue

    Case csAutoCalc
        mbAutoCalc = pvParamValue
    Case csCheckLine
        mlCheckLine = pvParamValue

    Case csGraphWidth
        mlGraphWidth = pvParamValue
    Case csGraphHeight
        mlGraphHeight = pvParamValue
'    Case csGraphSelect
'        mbGraphSelect = pvParamValue
    Case csGraphDisp
        miGraphDisp = pvParamValue
    Case csGraphFore
        msGraphFore = pvParamValue
    Case csGraphBack
        msGraphBack = pvParamValue
    Case csGraphPoint
        msGraphPoint = pvParamValue
    Case csGraphRank
        msGraphRank = pvParamValue
    Case csGraphPart
        msGraphPart = pvParamValue
    Case csGraphFlowR
        msGraphFlowR = pvParamValue
    Case csGraphFlowPnt
        msGraphFlowPnt = pvParamValue

'    Case csHelpFileName
'        msHelpFileName = pvParamValue

    Case csMainWidth
        mlMainWidth = pvParamValue
    Case csMainHeight
        mlMainHeight = pvParamValue
    Case csVisibleWindow
        miVisibleWindow = pvParamValue
    Case csMainToolbar
        mbMainToolbar = pvParamValue
'    Case csMainStatusbar
'        mbMainStatusbar = pvParamValue

    End Select
End Property

Public Function trReadIniFile() As Boolean
'---------------------------------------------------------------------------
'    : trReadIniFile()
' @@@\ : p[^t@Cǂݍ
' @@ : Ȃ
'   l : True= , False= s
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim liLoopCnt       As Integer          ' [vJE^
    Dim lsFileName      As String           ' t@C
    Dim lsLine          As String           ' ǂݍݕ
    Dim lsKeyStr        As String           ' p[^L[
    Dim liEqlPos        As Integer          ' ̈ʒu
    Dim lsPrmStr        As String           ' p[^l
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo trReadIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) <> "\" Then
        lsAppPath = lsAppPath & "\"
    End If
    lsFileName = lsAppPath & App.ProductName & ".ini"
    liFileNo = FreeFile

    mlMainWidth = 7500
    mlMainHeight = 6500
    miVisibleWindow = ciDefVisWindow
    mbMainToolbar = True
'    mbMainStatusbar = True

    mbSpecifyDate = True
    mdStartDate = Format(Date, "YYYY/MM/") & "01"
    mdEndDate = Format(Date, "YYYY/MM/DD")
    msScoreFile = App.Path & "MjScore.txt"
    miTableKind1 = ciDefTableKind1
    miTableKind2 = ciDefTableKind2

    mbAutoCalc = False
    mlCheckLine = clDefCheckLine

    mlGraphWidth = 5205
    mlGraphHeight = 3200
'    mbGraphSelect = False
    miGraphDisp = ciDefGraphDisp
    msGraphFore = csDefGraphFore
    msGraphBack = csDefGraphBack
    msGraphPoint = csDefGraphPoint
    msGraphRank = csDefGraphRank
    msGraphPart = csDefGraphPart
    msGraphFlowR = csDefGraphFlowR
    msGraphFlowPnt = csDefGraphFlowPnt

'    msHelpFileName = App.Path & csHelpFileName

    Open lsFileName For Input Access Read As liFileNo
    On Error Resume Next
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        lsLine = LTrim(lsLine)
        liEqlPos = InStr(lsLine, "=")

        If liEqlPos > 0 Then
            lsKeyStr = Left(lsLine, liEqlPos - 1)
            lsPrmStr = Mid(lsLine, liEqlPos + 1)

            Select Case UCase(Trim(lsKeyStr))
            Case UCase(csMainWidth)
                mlMainWidth = Abs(CLng(lsPrmStr))

            Case UCase(csMainHeight)
                mlMainHeight = Abs(CLng(lsPrmStr))

            Case UCase(csVisibleWindow)
                miVisibleWindow = CInt(lsPrmStr)
                If miVisibleWindow < 0 Or miVisibleWindow > ciDefVisWindow Then
                    miVisibleWindow = ciDefVisWindow
                End If

            Case UCase(csMainToolbar)
                mbMainToolbar = CBool(lsPrmStr)

'            Case UCase(csMainStatusbar)
'                mbMainStatusbar = CBool(lsPrmStr)

            Case UCase(csScoreFile)
                msScoreFile = Trim(lsPrmStr)

            Case UCase(csUserName)
                msUserName = Trim(lsPrmStr)

            Case UCase(csStartDate)
                mdStartDate = Trim(lsPrmStr)

            Case UCase(csSpecifyDate)
                mbSpecifyDate = CBool(lsPrmStr)

            Case UCase(csStartTime)
                mdStartTime = Trim(lsPrmStr)

            Case UCase(csEndDate)
                mdEndDate = Trim(lsPrmStr)

            Case UCase(csEndTime)
                mdEndTime = Trim(lsPrmStr)

            Case UCase(csTableKind1)
                miTableKind1 = CInt(lsPrmStr)
'                If miTableKind1 < ciTableNone Or miTableKind1 > ciTable4Play Then
'                    miTableKind1 = ciDefGameKind
'                End If

            Case UCase(csTableKind2)
                miTableKind2 = CInt(lsPrmStr)

            Case UCase(csAutoCalc)
                mbAutoCalc = CBool(lsPrmStr)

            Case UCase(csCheckLine)
                mlCheckLine = CLng(lsPrmStr)
                If mlCheckLine < clDefCheckLine Then
                    mlCheckLine = clDefCheckLine
                End If

            Case UCase(csGraphWidth)
                mlGraphWidth = Abs(CLng(lsPrmStr))

            Case UCase(csGraphHeight)
                mlGraphHeight = Abs(CLng(lsPrmStr))

'            Case UCase(csGraphSelect)
'                mbGraphSelect = CBool(lsPrmStr)

            Case UCase(csGraphDisp)
                miGraphDisp = CInt(lsPrmStr)
                If miGraphDisp < 0 Or miGraphDisp > 31 Then
                    miGraphDisp = ciDefGraphDisp
                End If

            Case UCase(csGraphFore)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphFore = Trim(lsPrmStr)
                End If

            Case UCase(csGraphBack)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphBack = Trim(lsPrmStr)
                End If

            Case UCase(csGraphPoint)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphPoint = Trim(lsPrmStr)
                End If

            Case UCase(csGraphRank)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphRank = Trim(lsPrmStr)
                End If

            Case UCase(csGraphPart)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphPart = Trim(lsPrmStr)
                End If

            Case UCase(csGraphFlowR)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphFlowR = Trim(lsPrmStr)
                End If

            Case UCase(csGraphFlowPnt)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msGraphFlowPnt = Trim(lsPrmStr)
                End If

'            Case UCase(csHelpFileName)
'                msHelpFileName = Trim(lsPrmStr)

            End Select
        End If
    Loop

    Close liFileNo
    trReadIniFile = True
    Exit Function

trReadIniFile_Error:
    Close liFileNo
    trReadIniFile = False
End Function

Public Function trWriteIniFile() As Boolean
'---------------------------------------------------------------------------
'    : trWriteIniFile()
' @@@\ : ݒt@C̏
' @@ : Ȃ
'   l : True= , False= s
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsIniFile       As String           ' ݒt@C
    Dim liRetCode       As Integer          ' ߂l
    Dim liLoopCnt       As Integer          ' [vJE^
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo trWriteIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) <> "\" Then
        lsAppPath = lsAppPath & "\"
    End If
    lsIniFile = lsAppPath & App.ProductName & ".ini"
    liFileNo = FreeFile

    Open lsIniFile For Output Access Write As liFileNo
    Print #liFileNo, "[" & App.ProductName & "]"
    Print #liFileNo, ""

    Print #liFileNo, csMainWidth & "=" & mlMainWidth
    Print #liFileNo, csMainHeight & "=" & mlMainHeight
    If miVisibleWindow <> ciDefVisWindow Then
        Print #liFileNo, csVisibleWindow & "=" & miVisibleWindow
    End If
    If mbMainToolbar <> True Then
        Print #liFileNo, csMainToolbar & "=" & mbMainToolbar
    End If
'    If mbMainStatusbar <> True Then
'        Print #liFileNo, csMainStatusbar & "=" & mbMainStatusbar
'    End If

    Print #liFileNo, csScoreFile & "=" & msScoreFile
    Print #liFileNo, csUserName & "=" & msUserName
    If mbSpecifyDate <> True Then
        Print #liFileNo, csSpecifyDate & "=" & mbSpecifyDate
    End If
    Print #liFileNo, csStartDate & "=" & Format(mdStartDate, "yyyy/m/d")
    Print #liFileNo, csStartTime & "=" & Format(mdStartTime, "h:n")
    Print #liFileNo, csEndDate & "=" & Format(mdEndDate, "yyyy/m/d")
    Print #liFileNo, csEndTime & "=" & Format(mdEndTime, "h:n")
    If miTableKind1 <> ciDefTableKind1 Then
        Print #liFileNo, csTableKind1 & "=" & miTableKind1
    End If
    If miTableKind2 <> ciDefTableKind2 Then
        Print #liFileNo, csTableKind2 & "=" & miTableKind2
    End If

    If mbAutoCalc <> False Then
        Print #liFileNo, csAutoCalc & "=" & mbAutoCalc
    End If
    If mlCheckLine <> clDefCheckLine Then
        Print #liFileNo, csCheckLine & "=" & mlCheckLine
    End If

    Print #liFileNo, csGraphWidth & "=" & mlGraphWidth
    Print #liFileNo, csGraphHeight & "=" & mlGraphHeight
'    If mbGraphSelect <> False Then
'        Print #liFileNo, csGraphSelect & "=" & mbGraphSelect
'    End If
    If miGraphDisp <> ciDefGraphDisp Then
        Print #liFileNo, csGraphDisp & "=" & miGraphDisp
    End If
    If msGraphFore <> csDefGraphFore Then
        Print #liFileNo, csGraphFore & "=" & msGraphFore
    End If
    If msGraphBack <> csDefGraphBack Then
        Print #liFileNo, csGraphBack & "=" & msGraphBack
    End If
    If msGraphPoint <> csDefGraphPoint Then
        Print #liFileNo, csGraphPoint & "=" & msGraphPoint
    End If
    If msGraphRank <> csDefGraphRank Then
        Print #liFileNo, csGraphRank & "=" & msGraphRank
    End If
    If msGraphPart <> csDefGraphPart Then
        Print #liFileNo, csGraphPart & "=" & msGraphPart
    End If
    If msGraphFlowR <> csDefGraphFlowR Then
        Print #liFileNo, csGraphFlowR & "=" & msGraphFlowR
    End If
    If msGraphFlowPnt <> csDefGraphFlowPnt Then
        Print #liFileNo, csGraphFlowPnt & "=" & msGraphFlowPnt
    End If

'    Print #liFileNo, csHelpFileName & "=" & msHelpFileName

    Close liFileNo
    trWriteIniFile = True
    Exit Function

trWriteIniFile_Error:
    liRetCode = MsgBox("ݒt@C݂̏Ɏs܂B" & vbCrLf & lsIniFile, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    trWriteIniFile = False
End Function
