Attribute VB_Name = "basCalc"
Option Explicit

Public Enum eiCalcId
    elGameNum
    elPoint
    elHighScore
    elLowScore
    elRankNum
    eiRankCont
    elRank

    elStageNum
    elMyTumo
    elMyRon
    elMyTyonbo
    elOtherTumo
    elOtherRon
    elOtherTyonbo
    elFlowTen
    elFlowNo
    elFlowOther
    elWinAllNum
    elWinValue

    eiGameAllPoint
    eiGameAllRank

    eiFlowR
    elFlowMaxR
    elFlowMinR

    eiFlowPoint
    elFlowMaxPnt
    elFlowMinPnt
End Enum

Private mlGameNum               As Long         ' S
Private mlPoint                 As Long         ' _
Private mlHighScore             As Long         ' ō_
Private mlLowScore              As Long         ' Œᓾ_
Private mlRankNum(4)            As Long         ' ʂƂ̐
Private miRankCont(4)           As Integer      ' őAiAsj
Private mlRank                  As Long         ' ʂ̍v

Private mlStageNum              As Long         ' ǐ
Private mlMyTumo                As Long         ' ̃c萔
Private mlMyRon                 As Long         ' ̃萔
Private mlMyTyonbo              As Long         ' ̃`{
Private mlOtherTumo             As Long         ' l̃c萔
Private mlOtherRon              As Long         ' l̃萔
Private mlOtherTyonbo           As Long         ' l̃`{
Private mlFlowTen               As Long         ' ǎepC
Private mlFlowNo                As Long         ' ǎm[e
Private mlFlowOther             As Long         ' ̑iv|vȂǁj
Private mlWinAllNum             As Long         ' 萔
Private mlWinValue(ciWinValue)  As Long         ' |Ƃ̂萔

Private miGameAllPoint()        As Integer      ' Ƃ̓_
Private miGameAllRank()         As Integer      ' Ƃ̏

Private miFlowR()               As Integer      ' q̐
Private mlFlowMaxR              As Long         ' q̐ځiōlj
Private mlFlowMinR              As Long         ' q̐ځiŒlj

Private miFlowPoint()           As Integer      ' v_̐
Private mlFlowMaxPnt            As Long         ' v_iōlj
Private mlFlowMinPnt            As Long         ' v_iŒlj

Public Property Get trCalcValue(ByVal piParamKey As Integer, Optional ByVal plIndex As Long) As Variant
'---------------------------------------------------------------------------
'    : trCalcValue()
' @@@\ : p[^l̎擾
' @@ : (I) piParamKey     p[^hc
'          : (I) plIndex        zԍ
'   l : p[^l
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Select Case piParamKey
    Case elGameNum
        trCalcValue = mlGameNum
    Case elPoint
        trCalcValue = mlPoint
    Case elHighScore
        trCalcValue = mlHighScore
    Case elLowScore
        trCalcValue = mlLowScore
    Case elRankNum
        trCalcValue = mlRankNum(plIndex)
    Case eiRankCont
        trCalcValue = miRankCont(plIndex)
    Case elRank
        trCalcValue = mlRank

    Case elStageNum
        trCalcValue = mlStageNum
    Case elMyTumo
        trCalcValue = mlMyTumo
    Case elMyRon
        trCalcValue = mlMyRon
    Case elMyTyonbo
        trCalcValue = mlMyTyonbo
    Case elOtherTumo
        trCalcValue = mlOtherTumo
    Case elOtherRon
        trCalcValue = mlOtherRon
    Case elOtherTyonbo
        trCalcValue = mlOtherTyonbo
    Case elFlowTen
        trCalcValue = mlFlowTen
    Case elFlowNo
        trCalcValue = mlFlowNo
    Case elFlowOther
        trCalcValue = mlFlowOther
    Case elWinAllNum
        trCalcValue = mlWinAllNum
    Case elWinValue
        trCalcValue = mlWinValue(plIndex)

    Case eiGameAllPoint
        trCalcValue = miGameAllPoint(plIndex)
    Case eiGameAllRank
        trCalcValue = miGameAllRank(plIndex)

    Case eiFlowR
        trCalcValue = miFlowR(plIndex)
    Case elFlowMaxR
        trCalcValue = mlFlowMaxR
    Case elFlowMinR
        trCalcValue = mlFlowMinR

    Case eiFlowPoint
        trCalcValue = miFlowPoint(plIndex)
    Case elFlowMaxPnt
        trCalcValue = mlFlowMaxPnt
    Case elFlowMinPnt
        trCalcValue = mlFlowMinPnt
    End Select
End Property

Public Function trUserCalc() As Boolean
'---------------------------------------------------------------------------
'    : trUserCalc()
' @@@\ : [U[̌vZ
' @@ : Ȃ
'   l : True= I, False= ُI
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim lbCalc          As Boolean      ' vZΏۃtO
    Dim lsUserName      As String       ' [U[
    Dim liUserNameLen   As Integer      ' [U[
    Dim liRankCont(4)   As Integer      ' ʂƂ̘AiAsj
    Dim liRank          As Integer      ' 
    Dim liBefRank       As Integer      ' PȌ
    Dim liPoint         As Integer      ' _
    Dim liStageValue    As Integer      ' ǂ̐l
    Dim liStagePoint    As Integer      ' ǂƂ̓_
    Dim liFindNo        As Integer      ' Ή|̔zԍ
    Dim lsLine          As String       ' ǂݍݍs
    Dim lsTable         As String       ' ꕗ
    Dim llMyR           As Long         ' q̒l
    Dim lsTableInfo     As String       ' Jns̒`
    Dim lsGameEnd       As String       ' Is̒`
    Dim lsHavePoint     As String       ' qs̒`
    Dim llCalcLine      As Long         ' vZs

    On Error GoTo trUserCalc_Error

    liFileNo = FreeFile
    Open basParam.trParamValue(csScoreFile) For Input Access Read As liFileNo

    lbCalc = False
    liBefRank = -1
    trInitRes
    lsUserName = basParam.trParamValue(csUserName)
    liUserNameLen = Len(lsUserName)
    lsTableInfo = basTableInfo.trTableInfoValue(elStartLine)
    lsGameEnd = basTableInfo.trTableInfoValue(elFinishLine)
    lsHavePoint = basTableInfo.trTableInfoValue(elRLine)

    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        llCalcLine = llCalcLine + 1
        If (llCalcLine Mod basParam.trParamValue(csCheckLine)) = 0 Then
            frmStatus.truStatusChange (llCalcLine / basParam.trParamValue(csCheckLine))
        End If
'        lsLine = LTrim(lsLine)

        ' 
        If Left(lsLine, Len(lsTableInfo)) = lsTableInfo Then
            lbCalc = trCheckTableInfo(lsLine)

        ' I
        ElseIf Left(lsLine, Len(lsGameEnd)) = lsGameEnd Then
            If lbCalc <> False Then
                lbCalc = False
            End If

        ' q
        ElseIf Left(lsLine, Len(lsHavePoint)) = lsHavePoint Then
            If lbCalc <> False Then
                lbCalc = trCheckRInfo(llMyR, lsLine)
            End If

        ElseIf lbCalc <> False Then
'            lsLine = Trim(lsLine)
            lsTable = Left(Trim(lsLine), 1)
            If liStageValue > 0 Then
                If InStr(lsLine, "c") Or InStr(lsLine, "") Then
                    If InStr(lsLine, "c") Then
                        mlMyTumo = mlMyTumo + 1
                    Else
                        mlMyRon = mlMyRon + 1
                    End If
                    liFindNo = -1
                    For liLoopCnt = 0 To basTableInfo.trTableInfoValue(elWinCont)
                        If InStr(lsLine, basTableInfo.trTableInfoValue(elWinStr, liLoopCnt)) Then
                            liFindNo = liLoopCnt
                            Exit For
                        End If
                    Next liLoopCnt
                    If liFindNo <> -1 Then
                        mlWinValue(liFindNo) = mlWinValue(liFindNo) + 1
                        mlWinAllNum = mlWinAllNum + 1
                    End If
                ElseIf InStr(lsLine, "") Then
                    mlFlowTen = mlFlowTen + 1
                ElseIf InStr(lsLine, "`{") Then
                    mlOtherTyonbo = mlOtherTyonbo + 1
                Else
                    mlFlowOther = mlFlowOther + 1
                End If
                liStageValue = 0
            ElseIf liStageValue < 0 Then
                If InStr(lsLine, "c") Then
                    mlOtherTumo = mlOtherTumo + 1
                ElseIf InStr(lsLine, "") Then
                    mlOtherRon = mlOtherRon + 1
                ElseIf InStr(lsLine, "") Then
                    If liStageValue = -1 Then
                        mlFlowNo = mlFlowNo + 1
                    Else
                        mlFlowOther = mlFlowOther + 1
                    End If
                ElseIf InStr(lsLine, "`{") Then
                        mlMyTyonbo = mlMyTyonbo + 1
                Else
                        mlFlowOther = mlFlowOther + 1
                End If
                liStageValue = 0
            ElseIf lsTable = "" Or lsTable = "" Or lsTable = "" Or lsTable = "k" Then
                mlStageNum = mlStageNum + 1
                liStagePoint = InStr(lsLine, " " & lsUserName & " ")
                liStageValue = -2
                If liStagePoint > 0 Then
                    If Mid(lsLine, liStagePoint + liUserNameLen + 2, 1) = "-" Then
                        liStageValue = -1
                    Else
                        liStageValue = 1
                    End If
                End If

            ' [U[ݒ
            ElseIf Mid(Trim(lsLine), 2, 2 + liUserNameLen + 1) = " " & lsUserName & " " Then
                mlGameNum = mlGameNum + 1

                liRank = Val(lsLine)
                mlRank = mlRank + liRank
                mlRankNum(liRank - 1) = mlRankNum(liRank - 1) + 1
                liPoint = Val(Right(lsLine, 4))
                mlPoint = mlPoint + liPoint
                If liPoint > mlHighScore Then
                    mlHighScore = liPoint
                End If
                If liPoint < mlLowScore Then
                    mlLowScore = liPoint
                End If
Dim liAllocNum As Integer
If liAllocNum < mlGameNum Then
liAllocNum = liAllocNum + 100
                ReDim Preserve miGameAllPoint(liAllocNum)
                ReDim Preserve miGameAllRank(liAllocNum)
                ReDim Preserve miFlowPoint(liAllocNum)
                ReDim Preserve miFlowR(liAllocNum)
End If
                miGameAllPoint(mlGameNum - 1) = liPoint
                miGameAllRank(mlGameNum - 1) = liRank
                If mlGameNum <> 1 Then
                    miFlowPoint(mlGameNum - 1) = miFlowPoint(mlGameNum - 2) + liPoint
                Else
                    miFlowPoint(mlGameNum - 1) = liPoint
                End If
                If mlFlowMaxPnt < miFlowPoint(mlGameNum - 1) Then
                    mlFlowMaxPnt = miFlowPoint(mlGameNum - 1)
                End If
                If mlFlowMinPnt > miFlowPoint(mlGameNum - 1) Then
                    mlFlowMinPnt = miFlowPoint(mlGameNum - 1)
                End If
                miFlowR(mlGameNum - 1) = llMyR
                If mlFlowMaxR < miFlowR(mlGameNum - 1) Then
                    mlFlowMaxR = miFlowR(mlGameNum - 1)
                End If
                If mlFlowMinR > miFlowR(mlGameNum - 1) Then
                    mlFlowMinR = miFlowR(mlGameNum - 1)
                End If

                If liBefRank = liRank Then
                    liRankCont(liRank - 1) = liRankCont(liRank - 1) + 1
                ElseIf liBefRank <> -1 Then
                    If (liBefRank > 0) And _
                        (miRankCont(liBefRank - 1) < liRankCont(liBefRank - 1) + 1) Then
                        miRankCont(liBefRank - 1) = liRankCont(liBefRank - 1) + 1
                    End If
                    liRankCont(liBefRank - 1) = 0
                End If
                liBefRank = liRank
            End If
        End If
    Loop
    If liBefRank > 0 Then
        If miRankCont(liBefRank - 1) < liRankCont(liBefRank - 1) + 1 Then
            miRankCont(liBefRank - 1) = liRankCont(liBefRank - 1) + 1
        End If
    End If

    Close #liFileNo
    trUserCalc = True
    Exit Function

trUserCalc_Error:
    Close #liFileNo
    MsgBox Err.Description, vbCritical, "vZG["
    trUserCalc = False
End Function

Public Sub trInitRes()
'---------------------------------------------------------------------------
'    : trInitRes()
' @@@\ : ʏ̏
' @@ : Ȃ
'   l : Ȃ
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^

    mlGameNum = 0
    mlPoint = 0
    mlHighScore = -99999
    mlLowScore = 99999
    For liLoopCnt = 0 To 4
        mlRankNum(liLoopCnt) = 0
        miRankCont(liLoopCnt) = 0
    Next liLoopCnt
    mlRank = 0

    mlStageNum = 0
    mlMyTumo = 0
    mlMyRon = 0
    mlMyTyonbo = 0
    mlOtherTumo = 0
    mlOtherRon = 0
    mlOtherTyonbo = 0
    mlFlowTen = 0
    mlFlowNo = 0
    mlFlowOther = 0
    mlWinAllNum = 0
    For liLoopCnt = 0 To basTableInfo.trTableInfoValue(elWinCont)
        mlWinValue(liLoopCnt) = 0
    Next liLoopCnt

    Erase miGameAllPoint
    Erase miGameAllRank

    Erase miFlowR
    mlFlowMaxR = -99999
    mlFlowMinR = 99999

    Erase miFlowPoint
    mlFlowMaxPnt = -99999
    mlFlowMinPnt = 99999
End Sub

Public Function trGetCalcLine() As Long
'---------------------------------------------------------------------------
'    : trGetCalcLine()
' @@@\ : XRAt@C̍s擾
' @@ : Ȃ
'   l : XRAt@C̍s
' @@ : 2000/01/20
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim lsLine          As String       ' ǂݍݍs
    Dim llCalcLine      As Long         ' vZs

    On Error GoTo aaGetAnalyzeLine_Error

    liFileNo = FreeFile
    Open basParam.trParamValue(csScoreFile) For Input Access Read As liFileNo

    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        llCalcLine = llCalcLine + 1
    Loop

    Close #liFileNo
    trGetCalcLine = llCalcLine
    Exit Function

aaGetAnalyzeLine_Error:
    Close #liFileNo
    trGetCalcLine = 0
End Function

Private Function trCheckTableInfo(ByVal psChkLine As String) As Boolean
'---------------------------------------------------------------------------
'    : trCheckTableInfo()
' @@@\ : ̃`FbN
' @@ : (I) psChkLine      `FbNs
'   l : True= Ώۑ, False= Ώ̑
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim liTableKind     As Integer      ' Eΐ
    Dim liSelKind       As Integer      ' IĂ
    Dim ldGameDate      As Date         ' t
    Dim lsChkLine       As String       ' `FbNs
    Dim ldStartDate     As Date         ' Jnt
    Dim ldEndDate       As Date         ' It
    Dim lsTableInfo     As String       ' Jns̒`
    Dim lcTableInfo     As cTableInfo   ' 

    trCheckTableInfo = False
    lsTableInfo = basTableInfo.trTableInfoValue(elStartLine)
    liSelKind = basParam.trParamValue(csTableKind2)
    lsChkLine = Mid(psChkLine, Len(lsTableInfo) + 1, Len(psChkLine) - Len(lsTableInfo) * 2)

    ' 
    For liLoopCnt = 1 To gcTableStr(2).Count
        Set lcTableInfo = gcTableStr(2).Item(liLoopCnt)

        If InStr(lsChkLine, lcTableInfo.trParamValue(csTableStr)) > 0 Then
            liTableKind = liTableKind + lcTableInfo.trParamValue(csTableId)
        End If
    Next liLoopCnt

    ' l
    If (liTableKind And liSelKind) > 0 Then
        liSelKind = basParam.trParamValue(csTableKind1)
        liTableKind = 0
        For liLoopCnt = 1 To gcTableStr(1).Count
            Set lcTableInfo = gcTableStr(1).Item(liLoopCnt)

            If InStr(lsChkLine, lcTableInfo.trParamValue(csTableStr)) > 0 Then
                liTableKind = liTableKind + lcTableInfo.trParamValue(csTableId)
            End If
        Next liLoopCnt

        ' 
        If (liTableKind And liSelKind) > 0 Then
            If basParam.trParamValue(csSpecifyDate) = False Then
                trCheckTableInfo = True
            Else
                ldGameDate = Format(Mid(lsChkLine, InStr(lsChkLine, "Jn") + 3), "yy/m/d")
                ldStartDate = basParam.trParamValue(csStartDate)
                ldEndDate = basParam.trParamValue(csEndDate)
                If (ldStartDate < ldGameDate) And (ldGameDate < ldEndDate) Then
                    trCheckTableInfo = True
                ElseIf (ldStartDate = ldGameDate) And (ldGameDate = ldEndDate) Then
                    ldGameDate = Format(Mid(lsChkLine, InStr(lsChkLine, "Jn") + 3), "h:n")
                    ldStartDate = basParam.trParamValue(csStartTime)
                    ldEndDate = basParam.trParamValue(csEndTime)
                    If (ldStartDate <= ldGameDate) And (ldGameDate <= ldEndDate) Then
                        trCheckTableInfo = True
                    End If
                ElseIf ldStartDate = ldGameDate Then
                    ldGameDate = Format(Mid(lsChkLine, InStr(lsChkLine, "Jn") + 3), "h:n")
                    ldStartDate = basParam.trParamValue(csStartTime)
                    If ldStartDate <= ldGameDate Then
                        trCheckTableInfo = True
                    End If
                ElseIf ldEndDate = ldGameDate Then
                    ldGameDate = Format(Mid(lsChkLine, InStr(lsChkLine, "Jn") + 3), "h:n")
                    ldEndDate = basParam.trParamValue(csEndTime)
                    If ldGameDate <= ldEndDate Then
                        trCheckTableInfo = True
                    End If
                End If
            End If
        End If
    End If
End Function

Private Function trCheckRInfo(ByRef plRValue As Long, ByVal psChkLine As String) As Boolean
'---------------------------------------------------------------------------
'    : trCheckRInfo()
' @@@\ : q̃`FbN
' @@ : (O) plRValue       ql
'          : (I) psChkLine      `FbNs
'   l : True= Ώۑ, False= Ώ̑
' @@ : 1999/12/15
'---------------------------------------------------------------------------
    Dim liLength        As Integer      ' ʒu
    Dim lsMyR           As String       ' q̒l

    liLength = InStr(psChkLine, basParam.trParamValue(csUserName) & " R")
    If liLength <> 0 Then
        lsMyR = Mid(psChkLine, liLength + Len(basParam.trParamValue(csUserName)) + 2)
        liLength = InStr(lsMyR, " ")
        If liLength = 0 Then
            plRValue = Val(lsMyR)
        Else
            plRValue = Val(Left(lsMyR, liLength))
        End If

        trCheckRInfo = True
    Else
        trCheckRInfo = False
    End If
End Function

Public Function trWriteResFile(ByVal psFileName As String) As Boolean
'---------------------------------------------------------------------------
'    : trWriteResFile()
' @@@\ : ʂt@Cɏo͂
' @@ : (I) psFileName     o̓t@C
'   l : True= , False= s
' @@ : 1999/12/22
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim liRetCode       As Integer      ' ߂l
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim lsOutputStr     As String       ' o͕
    Dim lsFormatStr     As String       ' o̓tH[}bg
    Dim lcTableInfo     As cTableInfo   ' 

    On Error GoTo trWriteResFile_Error

    liFileNo = FreeFile
    Open psFileName For Output As liFileNo

    Print #liFileNo, "[U[F " & basParam.trParamValue(csUserName)
    If basParam.trParamValue(csSpecifyDate) = False Then
        Print #liFileNo, "vZtF wȂ"
    Else
        Print #liFileNo, "vZtF " _
        & Format(basParam.trParamValue(csStartDate), "yyyy/m/d") & " " & Format(basParam.trParamValue(csStartTime), "h:n") & " ` " _
        & Format(basParam.trParamValue(csEndDate), "yyyy/m/d") & " " & Format(basParam.trParamValue(csEndTime), "h:n")
    End If

    If gcTableDisp(1).Count > 0 Then
        For liLoopCnt = 1 To gcTableDisp(1).Count
            Set lcTableInfo = gcTableDisp(1).Item(liLoopCnt)

            If basParam.trParamValue(csTableKind1) = lcTableInfo.trParamValue(csTableId) Then
                lsOutputStr = lcTableInfo.trParamValue(csTableStr)
                Exit For
            End If
        Next liLoopCnt
    End If
    If gcTableDisp(2).Count > 0 Then
        For liLoopCnt = 1 To gcTableDisp(2).Count
            Set lcTableInfo = gcTableDisp(2).Item(liLoopCnt)

            If basParam.trParamValue(csTableKind2) = lcTableInfo.trParamValue(csTableId) Then
                If lsOutputStr <> "" Then
                    lsOutputStr = lsOutputStr & "C" & lcTableInfo.trParamValue(csTableStr)
                Else
                    lsOutputStr = lcTableInfo.trParamValue(csTableStr)
                End If
                Exit For
            End If
        Next liLoopCnt
    End If
    Print #liFileNo, "F " & lsOutputStr
    Print #liFileNo, ""

    lsFormatStr = "@@@@@@@@"
    Print #liFileNo, "F " & Format(mlGameNum, lsFormatStr) & " "
    Print #liFileNo, "@_F " & Format(mlPoint, lsFormatStr) & " _"
    Print #liFileNo, "@ϏʁF " & Format(Format(mlRank / mlGameNum, "0.000"), lsFormatStr) & " "
    Print #liFileNo, "@ō_F " & Format(mlHighScore, lsFormatStr) & " _"
    Print #liFileNo, "@Œᓾ_F " & Format(mlLowScore, lsFormatStr) & " _"
    Print #liFileNo, "@ϓ_F " & Format(Format(mlPoint / mlGameNum, "0.000"), lsFormatStr) & " _"

    lsFormatStr = "@@@@@"
    For liLoopCnt = 0 To 3
        Print #liFileNo, "@" & StrConv(liLoopCnt + 1, vbWide) & "(" & Format(Format(mlRankNum(liLoopCnt) / mlGameNum * 100, "0"), "@@@") & "%)F " _
            & Format(mlRankNum(liLoopCnt), lsFormatStr) & " , A " & Format(miRankCont(liLoopCnt), lsFormatStr) & " "
    Next liLoopCnt
    
    Print #liFileNo, ""
    Print #liFileNo, "ǐF " & mlStageNum
    Print #liFileNo, "@{lF c@@(" & Format(Format(mlMyTumo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlMyTumo, lsFormatStr) & ""
    Print #liFileNo, "@@@@ @@(" & Format(Format(mlMyRon / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlMyRon, lsFormatStr) & ""
    Print #liFileNo, "@@@@ `{(" & Format(Format(mlMyTyonbo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlMyTyonbo, lsFormatStr) & ""
    Print #liFileNo, "@lF c@@(" & Format(Format(mlOtherTumo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlOtherTumo, lsFormatStr) & ""
    Print #liFileNo, "@@@@ @@(" & Format(Format(mlOtherRon / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlOtherRon, lsFormatStr) & ""
    Print #liFileNo, "@@@@ `{(" & Format(Format(mlOtherTyonbo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlOtherTyonbo, lsFormatStr) & ""
    Print #liFileNo, "@ǁF vX@(" & Format(Format(mlFlowTen / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlFlowTen, lsFormatStr) & ""
    Print #liFileNo, "@@@@ }CiX(" & Format(Format(mlFlowNo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlFlowNo, lsFormatStr) & ""
    Print #liFileNo, "@@@@ ̑@(" & Format(Format(mlFlowOther / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlFlowOther, lsFormatStr) & ""
    
    Print #liFileNo, ""
    Print #liFileNo, "萔F " & mlWinAllNum
    For liLoopCnt = 0 To basTableInfo.trTableInfoValue(elWinCont)
        lsOutputStr = Trim(basTableInfo.trTableInfoValue(elWinStr, liLoopCnt))
        If Len(lsOutputStr) < 5 Then
            lsOutputStr = lsOutputStr & Left("@@@@@", 5 - Len(lsOutputStr))
        End If
        If mlWinAllNum > 0 Then
            Print #liFileNo, "@" & Format(lsOutputStr, "!@@@@") & "(" & Format(Format(mlWinValue(liLoopCnt) / mlWinAllNum * 100, "0"), "@@@") & "%)" & Format(mlWinValue(liLoopCnt), lsFormatStr) & ""
        Else
            Print #liFileNo, "@" & Format(lsOutputStr, "!@@@@") & "(0%)" & Format(mlWinValue(liLoopCnt), lsFormatStr) & ""
        End If
    Next liLoopCnt

    Close liFileNo
    trWriteResFile = True
    Exit Function

trWriteResFile_Error:
    liRetCode = MsgBox("t@C݂̏Ɏs܂B" & vbCrLf & psFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    trWriteResFile = False
End Function

Public Function trPrintRes(ByVal ppDrawCtrl As Control) As Boolean
'---------------------------------------------------------------------------
'    : trPrintRes()
' @@@\ : ʂt@Cɏo͂
' @@ : (I) ppDrawCtrl     v^Rg[
'   l : True= , False= s
' @@ : 1999/12/22
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim lsOutputStr     As String       ' o͕
    Dim lsFormatStr     As String       ' o̓tH[}bg
    Dim llTextHeight    As Long         ' 
    Dim lcTableInfo     As cTableInfo   ' 
    Dim llCurrentX      As Long         ' \wʒu

    On Error GoTo trPrintRes_Error

    llCurrentX = Screen.Width * 3 / 4
    With ppDrawCtrl
        .FontSize = 8
        .FontName = "lr SVbN"
        .FontSize = 9
        llTextHeight = .TextHeight("0")
        .CurrentX = llCurrentX
        .CurrentY = 10
        ppDrawCtrl.Print "[U[F " & basParam.trParamValue(csUserName)
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "vZtF " & _
            basParam.trParamValue(csStartDate) & " " & Format(basParam.trParamValue(csStartTime), "yyyy/m/d h:n")
        .CurrentX = llCurrentX
        ppDrawCtrl.Print "@@@@@ ` " & _
            basParam.trParamValue(csEndDate) & " " & Format(basParam.trParamValue(csEndTime), "yyyy/m/d h:n")

        If gcTableDisp(1).Count > 0 Then
            For liLoopCnt = 1 To gcTableDisp(1).Count
                Set lcTableInfo = gcTableDisp(1).Item(liLoopCnt)

                If basParam.trParamValue(csTableKind1) = lcTableInfo.trParamValue(csTableId) Then
                    lsOutputStr = lcTableInfo.trParamValue(csTableStr)
                    Exit For
                End If
            Next liLoopCnt
        End If
        If gcTableDisp(2).Count > 0 Then
            For liLoopCnt = 1 To gcTableDisp(2).Count
                Set lcTableInfo = gcTableDisp(2).Item(liLoopCnt)

                If basParam.trParamValue(csTableKind2) = lcTableInfo.trParamValue(csTableId) Then
                    If lsOutputStr <> "" Then
                        lsOutputStr = lsOutputStr & "C" & lcTableInfo.trParamValue(csTableStr)
                    Else
                        lsOutputStr = lcTableInfo.trParamValue(csTableStr)
                    End If
                    Exit For
                End If
            Next liLoopCnt
        End If
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "F " & lsOutputStr

        .CurrentX = llCurrentX
        .CurrentY = .CurrentY + llTextHeight
        lsFormatStr = "@@@@@@@@"
        ppDrawCtrl.Print "F " & Format(mlGameNum, lsFormatStr) & " "
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@_F " & Format(mlPoint, lsFormatStr) & " _"
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@ϏʁF " & Format(Format(mlRank / mlGameNum, "0.000"), lsFormatStr) & " "
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@ō_F " & Format(mlHighScore, lsFormatStr) & " _"
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@Œᓾ_F " & Format(mlLowScore, lsFormatStr) & " _"
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@ϓ_F " & Format(Format(mlPoint / mlGameNum, "0.000"), lsFormatStr) & " _"

        lsFormatStr = "@@@@@"
        For liLoopCnt = 0 To 3
            .CurrentX = llCurrentX
'            .CurrentY = .CurrentY + llTextHeight
            ppDrawCtrl.Print "@" & StrConv(liLoopCnt + 1, vbWide) & "(" & Format(Format(mlRankNum(liLoopCnt) / mlGameNum * 100, "0"), "@@@") & "%)F " _
                & Format(mlRankNum(liLoopCnt), lsFormatStr) & " , A " & Format(miRankCont(liLoopCnt), lsFormatStr) & " "
        Next liLoopCnt

        .CurrentX = llCurrentX
        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "ǐF " & mlStageNum
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@{lF c@@(" & Format(Format(mlMyTumo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlMyTumo, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@@@@ @@(" & Format(Format(mlMyRon / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlMyRon, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@@@@ `{(" & Format(Format(mlMyTyonbo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlMyTyonbo, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@lF c@@(" & Format(Format(mlOtherTumo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlOtherTumo, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@@@@ @@(" & Format(Format(mlOtherRon / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlOtherRon, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@@@@ `{(" & Format(Format(mlOtherTyonbo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlOtherTyonbo, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@ǁF vX@(" & Format(Format(mlFlowTen / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlFlowTen, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@@@@ }CiX(" & Format(Format(mlFlowNo / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlFlowNo, lsFormatStr) & ""
        .CurrentX = llCurrentX
'        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "@@@@ ̑@(" & Format(Format(mlFlowOther / mlStageNum * 100, "0"), "@@@") & "%)" & Format(mlFlowOther, lsFormatStr) & ""

        .CurrentX = llCurrentX
        .CurrentY = .CurrentY + llTextHeight
        ppDrawCtrl.Print "萔F " & mlWinAllNum
        For liLoopCnt = 0 To basTableInfo.trTableInfoValue(elWinCont)
            .CurrentX = llCurrentX
'            .CurrentY = .CurrentY + llTextHeight
            lsOutputStr = Trim(basTableInfo.trTableInfoValue(elWinStr, liLoopCnt))
            If Len(lsOutputStr) < 5 Then
                lsOutputStr = lsOutputStr & Left("@@@@@", 5 - Len(lsOutputStr))
            End If
            If mlWinAllNum > 0 Then
                ppDrawCtrl.Print "  " & Format(lsOutputStr, "!@@@@") & "(" & Format(Format(mlWinValue(liLoopCnt) / mlWinAllNum * 100, "0"), "@@@") & "%)" & Format(mlWinValue(liLoopCnt), lsFormatStr) & ""
            Else
                ppDrawCtrl.Print "  " & Format(lsOutputStr, "!@@@@") & "(0%)" & Format(mlWinValue(liLoopCnt), lsFormatStr) & ""
            End If
        Next liLoopCnt
    End With

    trPrintRes = True
    Exit Function

trPrintRes_Error:
    trPrintRes = False
End Function
