Attribute VB_Name = "basTableInfo"
Option Explicit

' p[^L[
Public Const csTableDisp        As String = "TableInfo"
Public Const csTableId          As String = "TableId"
Public Const csTableStr         As String = "TableString"

Public Const csYakuCont         As String = "YakuCont"
Public Const csYakuStr          As String = "YakuString"
Public Const csStartLine        As String = "StartLine"
Public Const csFinishLine       As String = "FinishLine"
Public Const csRLine            As String = "RLine"

Public Const ciTableNum         As Integer = 2

Public Enum eiTableInfoId
    elWinCont
    elWinStr
    elStartLine
    elFinishLine
    elRLine
End Enum

' o[
Public gcTableDisp(ciTableNum)  As Collection   ' 
Public gcTableStr(ciTableNum)   As Collection   ' 
Public miWinCont                As Integer      ' |̐
Public msWinStr(ciWinValue)     As String       ' |̕
Public msStartLine              As String       ' Jns
Public msFinishLine             As String       ' Is
Public msRLine                  As String       ' q̍s

Public Property Get trTableInfoValue(ByVal piParamKey As Integer, Optional ByVal plIndex As Long) As Variant
'---------------------------------------------------------------------------
'    : trTableInfoValue()
' @@@\ : p[^l̎擾
' @@ : (I) piParamKey     p[^hc
'          : (I) plIndex        zԍ
'   l : p[^l
' @@ : 1999/12/20
'---------------------------------------------------------------------------
    Select Case piParamKey
    Case elWinCont
        trTableInfoValue = miWinCont
    Case elWinStr
        trTableInfoValue = msWinStr(plIndex)
    Case elStartLine
        trTableInfoValue = msStartLine
    Case elFinishLine
        trTableInfoValue = msFinishLine
    Case elRLine
        trTableInfoValue = msRLine
    End Select
End Property

Public Sub trInitFixedInfo()
'---------------------------------------------------------------------------
'    : trInitFixedInfo()
' @@@\ : Œ̏
' @@ : Ȃ
'   l : Ȃ
' @@ : 1999/12/20
'---------------------------------------------------------------------------
    Dim liTableNum          As Integer      ' e[u

    For liTableNum = 0 To ciTableNum
        Set gcTableDisp(liTableNum) = New Collection
        Set gcTableStr(liTableNum) = New Collection
    Next liTableNum

    trReadFixedInfo
End Sub

Private Sub trReadFixedInfo()
'---------------------------------------------------------------------------
'    : trReadFixedInfo()
' @@@\ : Œt@C̓ǂݍ
' @@ : Ȃ
'   l : Ȃ
' @@ : 1999/12/20
'---------------------------------------------------------------------------
    Dim llLoopCnt           As Long         ' [vJE^
'    Dim liTableNum          As Integer      ' e[u
    Dim liFileNo            As Integer      ' t@Cԍ
    Dim lsFileName          As String       ' t@C
    Dim lsLine              As String       ' ǂݍݕ
    Dim lsKeyStr            As String       ' p[^L[
    Dim liEqlPos            As Integer      ' ̈ʒu
    Dim lsPrmStr            As String       ' p[^l
    Dim liIndex             As Integer      ' CfbNXԍ
    Dim lvValues            As Variant      ' ݒl
    Dim lcTableInfo         As cTableInfo   ' 
    Dim lsAppPath           As String       ' AvP[ṼpX

    On Error GoTo ptReadDatFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) <> "\" Then
        lsAppPath = lsAppPath & "\"
    End If
    lsFileName = lsAppPath & App.ProductName & ".dat"
    liFileNo = FreeFile

    miWinCont = -1
    msStartLine = "===== "
    msFinishLine = "----- "
    msRLine = "  _"

'    For liTableNum = 0 To ciTableNum
'        For llLoopCnt = 1 To gcTableStr(liTableNum).Count
'            Call gcTableStr(liTableNum).Remove(llLoopCnt)
'        Next llLoopCnt
'    Next liTableNum

    Open lsFileName For Input Access Read As liFileNo
    On Error Resume Next
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        lsLine = LTrim(lsLine)
        liEqlPos = InStr(lsLine, "=")

        If liEqlPos > 0 Then
            lsKeyStr = Trim(Left(lsLine, liEqlPos - 1))
            lsPrmStr = Mid(lsLine, liEqlPos + 1)

            Select Case UCase(lsKeyStr)
            Case UCase(csTableStr) & "1", UCase(csTableStr) & "2"
                liEqlPos = InStr(lsPrmStr, ",")
                If liEqlPos > 0 Then
                    Set lcTableInfo = New cTableInfo

                    lcTableInfo.trParamValue(csTableId) = Left(lsPrmStr, liEqlPos - 1)
                    lcTableInfo.trParamValue(csTableStr) = Mid(lsPrmStr, liEqlPos + 1)
                    Call gcTableStr(Right(lsKeyStr, 1)).Add(lcTableInfo)
                End If

            Case UCase(csTableDisp) & "1", UCase(csTableDisp) & "2"
                liEqlPos = InStr(lsPrmStr, ",")
                If liEqlPos > 0 Then
                    Set lcTableInfo = New cTableInfo

                    lcTableInfo.trParamValue(csTableId) = Left(lsPrmStr, liEqlPos - 1)
                    lcTableInfo.trParamValue(csTableStr) = Mid(lsPrmStr, liEqlPos + 1)
                    Call gcTableDisp(Right(lsKeyStr, 1)).Add(lcTableInfo)
                End If

            Case UCase(csYakuStr)
                If miWinCont < ciWinValue Then
                    miWinCont = miWinCont + 1
                    msWinStr(miWinCont) = lsPrmStr
                End If

            Case UCase(csStartLine)
                msStartLine = lsPrmStr

            Case UCase(csFinishLine)
                msFinishLine = lsPrmStr

            Case UCase(csRLine)
                msRLine = lsPrmStr
            End Select
        End If
    Loop
    Close liFileNo

    Exit Sub

ptReadDatFile_Error:
    MsgBox "vZt@C̓ǂݍ݂Ɏs܂B" & vbCrLf & lsFileName, vbCritical, "G["
    Close liFileNo
End Sub
